CMD_LSOF="/usr/bin/lsof"
ENV_VALID=0
ENV_PLATFORM_INVALID=1
ENV_PORT_INVALID=2


get_vs_cfg()
{
    local section=$1
    local key=$2
    local has_section=$(${CMD_PYTHON} -c "import configparser; config = configparser.RawConfigParser(); config.read('${VS_CONF}'); print(config.has_section('${section}'))")

    if [ x"${has_section}" == x"${FALSE}" ]; then
        ${CMD_PYTHON} -c "import configparser; config = configparser.RawConfigParser(); config.read('${VS_CONF}'); config.add_section('${section}'); fd = open('${VS_CONF}', 'w'); config.write(fd); fd.close()"
    fi

    ${CMD_PYTHON} -c "import configparser; config = configparser.RawConfigParser(); config.read('${VS_CONF}'); print(config.get('${section}', '${key}'));"
}

platform_check()
{
    local is_active
    local is_valid

    is_active=$(get_srv_status ${PKG_RES})
    if [ x"${is_active}" == x"inactive" ]; then
        ${CMD_ECHO} ${FALSE}
        return
    fi

    is_valid=$(dbus_call com.ivs.resource /com/ivs/resource/machine com.ivs.resource.machine Valid)
    is_valid=$(${CMD_ECHO} ${is_valid}| awk '{print $2}')
    if [ x"${is_valid}" == x"true" ]; then
        ${CMD_ECHO} ${TRUE}
        return
    fi

    ${CMD_ECHO} ${FALSE}
}

port_check_result=""
port_in_use_check()
{
    local web_port=$(get_vs_cfg vs web_port)
    local ssl_port=$(get_vs_cfg vs ssl_port)
    local web_port_in_use=$($CMD_LSOF -i:$web_port)
    local ssl_port_in_use=$($CMD_LSOF -i:$ssl_port)

    if [ -n "${web_port_in_use}" ] && [ -n "${ssl_port_in_use}" ]; then
        port_check_result=$FALSE
    else
        port_check_result=$TRUE
    fi
}

env_check()
{
    if [ x"$(platform_check)" == x"${FALSE}" ]; then
        ${CMD_ECHO} ${ENV_PLATFORM_INVALID}
    elif [ x"${port_check_result}" == x"${FALSE}" ]; then
        ${CMD_ECHO} ${ENV_PORT_INVALID}
    else
        ${CMD_ECHO} ${ENV_VALID}
    fi
}
